import { getTestElement } from '../../support/cypress-helper';
import { convertToDataTestId } from '../../support/tech-util';

export class AggregationMappingE2EComponent {
  private readonly headerText: string = 'aggregation-mapping-header-text';
  private readonly weitereFelderAuswertenButton = 'weitere-felder-auswerten-button';

  public getHeaderText(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.headerText);
  }

  public getWeitereFelderAuswertenButton(): Cypress.Chainable<Element> {
    return cy.getTestElement(this.weitereFelderAuswertenButton);
  }

  public getListItem(name: string): AggregationMappingListItemE2EComponent {
    return new AggregationMappingListItemE2EComponent(name);
  }
}

export class AggregationMappingListItemE2EComponent {
  private root: string;

  private readonly listItemName: string = 'list-item-name';
  private readonly listItemFormEngineName: string = 'list-item-form-engine-name';
  private readonly listItemFormId: string = 'list-item-form-id';

  constructor(root: string) {
    this.root = convertToDataTestId(root);
  }

  public getRoot(): Cypress.Chainable<Element> {
    return getTestElement(this.root);
  }

  public getName(): Cypress.Chainable<Element> {
    return this.getRoot().findTestElementWithClass(this.listItemName);
  }

  public getFormEngineName(): Cypress.Chainable<Element> {
    return this.getRoot().findTestElementWithClass(this.listItemFormEngineName);
  }

  public getFormId(): Cypress.Chainable<Element> {
    return this.getRoot().findTestElementWithClass(this.listItemFormId);
  }
}
