import { SnackBarE2EComponent } from '../components/ui/snackbar.e2e.component';
import { contains, exist } from '../support/cypress.util';

export class E2EAppVerifier {
  private readonly snackBar: SnackBarE2EComponent = new SnackBarE2EComponent();

  public verifyRevokableSnackbar(message: string): void {
    this.verifySnackbar(message);
    exist(this.snackBar.getRevokeButton());
  }

  public verifySnackbar(message: string): void {
    exist(this.snackBar.getCloseButton());
    exist(this.snackBar.getMessage());
    contains(this.snackBar.getMessage(), message);
  }
}
