import { VorgangFormularButtonsE2EComponent } from '../../components/vorgang/vorgang-formular-buttons.e2e.components';
import { VorgangSubnavigationE2EComponent } from '../../components/vorgang/vorgang-subnavigation';
import { waitForSpinnerToDisappear } from '../../page-objects/main.po';
import { exist } from '../../support/cypress.util';

export class E2EVorgangExecutor {
  private readonly formularButtons: VorgangFormularButtonsE2EComponent = new VorgangFormularButtonsE2EComponent();
  private readonly subnavigation: VorgangSubnavigationE2EComponent = new VorgangSubnavigationE2EComponent();

  public abschliessenByIconButton(): void {
    this.doClick(this.subnavigation.getAbschliessenIconButton());
  }

  public bearbeitenByIconButton(): void {
    this.doClick(this.subnavigation.getBearbeitenIconButton());
  }

  public verwerfenByIconButton(): void {
    this.doClick(this.subnavigation.getVerwerfenIconButton());
  }

  public wiedereroeffnenByButton(): void {
    this.doClick(this.formularButtons.getWiedereroeffnenButton());
  }

  public wiedereroeffnenByIconButton(): void {
    this.doClick(this.subnavigation.getWiedereroeffnenIconButton());
  }

  public zurueckholenByIconButton(): void {
    this.doClick(this.subnavigation.getZurueckholenIconButton());
  }

  public zurueckstellenByIconButton(): void {
    this.doClick(this.subnavigation.getZurueckstellenIconButton());
  }

  private doClick(element: Cypress.Chainable<JQuery<Element>>): void {
    exist(element);
    element.click();
    waitForSpinnerToDisappear();
  }
}
