/*
 * Copyright (C) 2023 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { HelpMenuE2EComponent } from '../components/user-assistance/help-menu.component.e2e';
import { CurrentUserProfileE2EComponent } from '../components/user-profile/current-user-profile.component.e2e';
import { UserSettingsE2EComponent } from '../components/user-settings/user-settings.component.e2e';
import { VorgangSearchE2EComponent } from '../components/vorgang/vorgang-search.e2e.component';

export class HeaderE2EComponent {
  private readonly locatorLogo: string = 'alfa-logo';
  private readonly locatorRoot: string = 'header';
  private readonly accessibilityIcon: string = 'accessibility-button';

  private readonly helpMenu: HelpMenuE2EComponent = new HelpMenuE2EComponent();
  private readonly userSettings: UserSettingsE2EComponent = new UserSettingsE2EComponent();
  private readonly currentUserProfile: CurrentUserProfileE2EComponent = new CurrentUserProfileE2EComponent();
  private readonly vorgangSearch: VorgangSearchE2EComponent = new VorgangSearchE2EComponent();

  public getRoot() {
    return cy.getTestElement(this.locatorRoot);
  }

  public getLogo() {
    return cy.getTestElement(this.locatorLogo);
  }

  public getVorgangSearch(): VorgangSearchE2EComponent {
    return this.vorgangSearch;
  }

  public getHelpMenu(): HelpMenuE2EComponent {
    return this.helpMenu;
  }

  public getUserSettings(): UserSettingsE2EComponent {
    return this.userSettings;
  }

  public getCurrentUserProfile(): CurrentUserProfileE2EComponent {
    return this.currentUserProfile;
  }

  public getAccessibilityIcon(): Cypress.Chainable<JQuery<HTMLElement>> {
    return cy.getTestElement(this.accessibilityIcon);
  }
}
