import { Component, Input } from '@angular/core';
import { ReactiveFormsModule, UntypedFormGroup } from '@angular/forms';
import { TextEditorComponent } from '@ods/component';
import { UserFormService } from '../user.formservice';
import { UserFormDataNameComponent } from './user-form-data-name/user-form-data-name.component';

@Component({
  selector: 'admin-user-form-data',
  standalone: true,
  imports: [ReactiveFormsModule, TextEditorComponent, UserFormDataNameComponent],
  templateUrl: './user-form-data.component.html',
})
export class UserFormDataComponent {
  @Input() formGroupParent: UntypedFormGroup;
  @Input() userName: string;
  @Input() isPatch: boolean;

  public readonly UserFormService = UserFormService;
}
