/*
 * Copyright (C) 2023 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { Action } from '@ngrx/store';
import { UserProfileState, initialState, reducer } from './user-profile.reducer';

import * as UserProfileActions from './user-profile.actions';

describe('UserProfile Reducer', () => {
  describe('unknown action', () => {
    it('should return current state', () => {
      const action = {} as Action;

      const result = reducer(initialState, action);

      expect(result).toBe(initialState);
    });
  });

  describe('userProfileSearchVisibilty', () => {
    describe('on "showUserProfileSearch" action', () => {
      it('should set userProfileSearchVisibilty to true', () => {
        const action = UserProfileActions.showUserProfileSearch();

        const state: UserProfileState = reducer(initialState, action);

        expect(state.userProfileSearchVisibilty).toBeTruthy();
      });
    });

    describe('on "hideUserProfileSearch" action', () => {
      it('should set userProfileSearchVisibilty to false', () => {
        const action = UserProfileActions.hideUserProfileSearch();

        const state: UserProfileState = reducer(initialState, action);

        expect(state.userProfileSearchVisibilty).toBeFalsy();
      });
    });
  });
});
